package dev.ninjdai.werewolf.uhc.events;

import dev.ninjdai.werewolf.uhc.UHCPlayer;
import dev.ninjdai.werewolf.uhc.roles.Role;
import dev.ninjdai.werewolf.uhc.roles.Roles;
import dev.ninjdai.werewolf.uhc.teams.Team;
import dev.ninjdai.werewolf.uhc.teams.Teams;
import dev.ninjdai.werewolf.uhc.teams.WinCondition;
import io.github.togar2.pvp.events.EntityPreDeathEvent;
import net.minestom.server.MinecraftServer;
import net.minestom.server.entity.GameMode;
import net.minestom.server.entity.Player;
import net.minestom.server.event.EventFilter;
import net.minestom.server.event.EventNode;
import net.minestom.server.event.trait.EntityEvent;

public class UHCPlayerDeathEvent {
    public static void onPlayerDeath(EntityPreDeathEvent event) {
        UHCPlayer player = (UHCPlayer) event.getEntity();
        if(event.getDamage().getAttacker() instanceof UHCPlayer killer) {
            Team team = Team.teamMap.get(killer.getUHCTeam().getId());
            WinCondition.checkTeamWin(team, event.getInstance().getPlayers());
        }

        event.setCancelDeath(true);
        player.toggleSpectating();


        var timedPlayerDeath = new TimedPlayerDeath(player, event.getDamage(), 15);

        player.getUHCRole().onPlayerDeath(player, timedPlayerDeath);
    }

    public static void register() {
        EventNode<EntityEvent> playerNode = EventNode.type("player-listener", EventFilter.ENTITY);
        MinecraftServer.getGlobalEventHandler().addChild(playerNode);

        playerNode.addListener(EntityPreDeathEvent.class, event -> {
            if (event.getEntity() instanceof UHCPlayer) onPlayerDeath(event);
        });
    }
}
